Subject: bug#38181: Actual height of mode-line not taken into account

From: Eli Zaretskii <[email-masked]>
Date: Mon, 18 Nov 2019 17:42:53 +0200

> Cc: [email-masked], [email-masked]
> From: martin rudalics <[email-masked]>
> Date: Mon, 18 Nov 2019 10:44:56 +0100
> 
>  > Thanks.  So the only thing that's missing is that it should call
>  > display_mode_lines, and then look at DESIRED_MODE_LINE_HEIGHT instead
>  > of WINDOW_MODE_LINE_HEIGHT?
> 
> I suppose so.  But please always keep in mind that the window code
> does not handle problems caused by specifications in the mode and
> header lines immediately.

What kind of problems are we talking about?

> For example, it will not auto-resize a one-line window when its mode
> line height is increased to more than its text height.

That's a separate issue, isn't it?

>  >> Still, it will penalize every
>  >> ‘fit-window-to-buffer’ call (without a redisplay, though).
>  >
>  > Why "penalize"?
> 
> Because 'fit-window-to-buffer' now has to calculate the mode line
> height which it didn't before and which for the majority of users
> never changes.

Is that a significant problem?  It's not like fit-window-to-buffer is
expected to be called in a tight loop, right?  Displaying a mode line
is no more expensive (actually, even usually expensive) than calling
vertical-motion to move one line, and we would never think twice
before adding a call to the latter, right?